//
/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
//


// sample connect/execute/disconnect to DES
/*
 * Filename       : TExeFetchPrevDES.cpp
 * Description    : Connect to DES Datastore.
 *                  Create query string with advanced options.
 *                  Specifies category & sources for search
 *                  Get the scrollable result in a resultset cursor and set 	 * 		    cursor position to DK_CM_LAST
 *                  Loop thru results and fetch the result using fetchPrevious
 *                  The fetchPrevious call might rerun the search for 
 *		    previous page
 *                  Display documents found and their parts and attributes,
 *                  of results.
 *                  if folders found display them and their documents/
 *                  folders.
 *                  Disconnect from DES Datastore.
 */

#include <iostream.h>
#include <stdio.h>                
#include <DKConstant.h>
#include <DKDatastoreDES.hpp>
#include <DKException.hpp>
#include <DKString.hpp>
#include <dkResultSetCursor.hpp>
#include <dkResultSetCursorScrollable.hpp>
#include <DKDDO.hpp>
#include <DKAny.hpp>
#include <DKPid.hpp>
#include <dkCollection.hpp>
#include <DKBlobDES.hpp>
#include <DKPidXDODES.hpp>
#include <DKEnvironment.hpp>
#include <DKDate.hpp>

void main(int argc, char *argv[])
{
    cout << "begin..." << endl;

    // Indicate this is a Console Application on Windows NT/95 for error
    // message code page conversion to OEM code page. If this was a Windows
    // GUI (Graphic User Interface) Application this would not be necessary
    // because DK_SS_WINDOWS is the default.
    DKEnvironment::setSubSystem(DK_SS_CONSOLE);

    //-------------------------------------------------------------- 
    // Checking for input parameters
    //--------------------------------------------------------------   
    if (argc < 5)
    {
     cout<<"Usage: "<<endl;
     cout<< argv[0] << "  <libsrv> <userid> <pw> <PORT=80;DESAPPID=appid;DESAPPPW=apppass[;DESCFGPATH=<des cfg file>;DESLOCALE=<locale>;]>" << endl;
     return;
    }
    // ### get input parameters
    DKString libsrv = DKString(argv[1]);
    DKString userid = DKString(argv[2]);
    DKString pw = DKString(argv[3]);
	DKString str = argv[4];
    
    DKDatastoreDES dsDES;

    try {
    dkResultSetCursorScrollable* pCur = 0;
    cout << "Datastore DES created" << endl;
    cout << "connecting to datastore" << endl;
    dsDES.connect(libsrv,userid,pw,str);
    cout << "datastore connected " << libsrv << " userid - " << userid << endl;

    // Specifying multiple sources & Categories
    DKString cmd = "SEARCH=(DATABASE=(ES Documentation);";

    // GQL
    cmd += "COND=((IN \"Subject\" \"data\")));";

    // Advanced options
    cmd += "OPTION=(MAX_RESULTS=8;TIME_LIMIT=30;SOURCE_MAX_HITS=10;MAX_RESULTS_PER_PAGE=5;FIND_ALL_WORDS=(NO);SORT=(DocRank,DESC);RESULTS_WHEN_AVAILABLE=(NO);PAGE_SCROLL=(1););";
	
    cout << "query string " << cmd << endl;
    cout << "executing query" << endl;
    pCur = (dkResultSetCursorScrollable*) dsDES.execute(cmd);
    cout << "query executed" << endl;

    DKDDO *p = 0;
    dkDataObjectBase *pDOBase = 0;
    DKDDO *pDDO = 0;
    dkXDO *pXDO = 0;
    DKAny a;
    ushort j = 0;
    ushort k = 0;
    ushort val = 0;
    ushort cnt = 1;
    DKString strData = "";
    DKString strDataName = "";
    dkCollection* pdCol = 0;
    dkIterator*  pdIter = 0;
    ushort numDataItems = 0;
	DKPidXDODES *pidXDO = 0;
	DKPid *pid = 0;
    DKString strPid;
	long pidIdCnt = 0;
	long pidIndex = 0;
	cout <<"cardinality() = "<<pCur->cardinality() << endl;
	cout <<"Setcursor position to DK_CM_LAST"<<endl;
	pCur->setPosition(DK_CM_LAST,(long)NULL);


    while (pCur->isValid())
    {
	cout<<"Trying fetchPrevious()"<<endl;
     p = pCur->fetchPrevious();
     if (p != 0)
     {
      cout << "==========> " << "Item " << pCur->getPosition() << " <=========" << endl;
      numDataItems = p->dataCount();
	  pid = (DKPid*)p->getPidObject();
	  strPid = pid->pidString();
	  cout << "pid string " << strPid << endl;
	  cout << "pid id string " << pid->getId() << endl;
	  strPid = pid->getIdString();
	  cout << "pid idString " << strPid << endl;
      pidIdCnt = pid->getIdStringCount();
	  cout << "pid idString cnt " << pidIdCnt << endl;
	  strPid = pid->getPrimaryId();
	  cout << "pid primary id " << strPid << endl;
	  pidIndex = 0;
	  strPid = pid->getIdString(pidIndex);
	  cout << "pid item id " << strPid << endl;
      k = p->propertyId(DK_PROPERTY_ITEM_TYPE);
      if (k > 0)
      {
       a = p->getProperty(k);
       val = a;
       cout << "******************************" << endl;
       switch (val)
       {
        case DK_DOCUMENT :
	  	 cout << "Item is a document " << endl;
         break;
		default:
           cout << " Item is not recognized " << endl;
		break;
       }
       cout << "******************************" << endl;
      }
      cout << "Number of Data Items " << numDataItems << endl;
      for (j = 1; j <= numDataItems; j++)
      {
       a = p->getData(j);
       strDataName = p->getDataName(j);
       switch (a.typeCode())
       {
        case DKAny::tc_string :
		{
         strData = a;
         cout << "attribute name 1: " << strDataName << " value : " << strData << endl;
		}
         break;
        case DKAny::tc_long :
		{
         long l = a;
         cout << "attribute name 2: " << strDataName << " value : " << l << endl;
		}
         break;
        case DKAny::tc_double :
		{
         double db = a;
         cout << "attribute name 3: " << strDataName << " value : " << db << endl;
		}
         break;
        case DKAny::tc_timestamp :
		{
         DKTimestamp tt = a;
         cout << "attribute name 4: " << strDataName << " value : " 
				<< tt.getMonth() << "/" << tt.getDay() << "/" << tt.getYear() << " " 
				<< tt.getHours() << ":" << tt.getMinutes() << ":" << tt.getSeconds() << endl;
		}
         break;
        case DKAny::tc_dobase :
		{
			pDOBase = a;
			pXDO = (dkXDO*)pDOBase;
			cout << "attribute name 5: " << strDataName << " value : " << endl;
			pidXDO = (DKPidXDODES*)pXDO->getPidObject();
			cout << "XDO pid database name " << pidXDO->getDatabaseName() << endl;
			cout << "XDO pid docId " << pidXDO->getDocId() << endl;
			cout << "XDO mimetype " << pXDO->getMimeType() << endl;
		}
		break;
	
        case DKAny::tc_collection :
	{
         pdCol = a;
         cout << strDataName << " collection name : " << strDataName << endl;
         cout << "--------------------------------------" << endl;
         pdIter = pdCol->createIterator();
         ushort b = 0;
         while (pdIter->more() == TRUE)
	 {
	  b++;
          cout << "  -------------------------------------------------" << endl;
	  a = *(pdIter->next());
      switch (a.typeCode())
      {
        case DKAny::tc_string :
		{
         strData = a;
         cout << "attribute name 6: " << strDataName << " value : " << strData << endl;
		}
         break;
        case DKAny::tc_long :
		{
         long l = a;
         cout << "attribute name 7: " << strDataName << " value : " << l << endl;
		}
         break;
        case DKAny::tc_double :
		{
         double db = a;
         cout << "attribute name 8: " << strDataName << " value : " << db << endl;
		}
         break;
        case DKAny::tc_timestamp :
		{
         DKTimestamp tt = a;
         cout << "attribute name : " << strDataName << " value : " 
				<< tt.getMonth() << "/" << tt.getDay() << "/" << tt.getYear() << " " 
				<< tt.getHours() << ":" << tt.getMinutes() << ":" << tt.getSeconds() << endl;
		}
         break;
        case DKAny::tc_dobase :
		{
			pDOBase = a;
			pXDO = (dkXDO*)pDOBase;
			cout << "attribute name : " << strDataName << " value : " << endl;
			pidXDO = (DKPidXDODES*)pXDO->getPidObject();
			cout << "XDO pid database name " << pidXDO->getDatabaseName() << endl;
			cout << "XDO pid docId " << pidXDO->getDocId() << endl;
			cout << "XDO mimetype " << pXDO->getMimeType() << endl;
			DKString str = "c:\\temp\\temp";
		}
		break;
	  }
			ushort usCount = p->dataPropertyCount(j);
			for (ushort k = 1; k <= usCount; k++)
			{
				a = p->getDataProperty(j, k);
				cout << " property " << k << " " << a << endl;
			}	
         }

         if (b == 0)
	 {
	   cout << strDataName << " collection has no elements " << endl;
	 }
         cout << "  -------------------------------------------------" << endl;
         break;
	}
       }
			ushort usCount = p->dataPropertyCount(j);
			for (ushort k = 1; k <= usCount; k++)
			{
				a = p->getDataProperty(j, k);
				cout << " property " << k << " " << a << endl;
			}	
      }
      cnt++;
      delete p;
     }
    }
     cout << "Total Item count is " << cnt-1 << endl;
     if (pCur != 0)
       delete pCur;
     dsDES.disconnect();
     cout << "datastore disconnected" << endl;
    }
    catch(DKException &exc)
    {

      cout << "Error id " << exc.errorId() << endl;
      cout << "Exception id " << exc.exceptionId() << endl;
      for(unsigned long i = 0; i< exc.textCount();i++)
      {
       cout << "Error text: " << exc.text(i) << endl;
      }
      for (unsigned long g=0; g< exc.locationCount();g++)
      {
       const DKExceptionLocation* p = exc.locationAtIndex(g);
       cout << "Filename: " << p->fileName() << endl;
       cout << "Function: " << p->functionName() << endl;
       cout << "LineNumber: " << p->lineNumber() << endl;
      }
      cout << "Exception Class Name: " << exc.name() << endl;
    }
    cout << "done ..." << endl;

}
