/************************************************************************/
/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
/************************************************************************/

/*
 * Filename       : TADLstFed.cpp
 * Description    : test add, delete, list schema-mappings
 *                : Need to run the following program first
 *                  TADLServersFed <cmbdb> <userid> <pw> add
 *                  TADLsmFed      <cmbdb> <userid> <pw> add
 *
 *                  This program will create a fed entity 'FedDemo' which mapped to
 *                  DLDEMO on Talisman2 and Mufasa.
 *
 */

#include <iostream.h>
#include <stdio.h>                
#include <DKConstant.h>
#include <DKConstant2Fed.h>
#include <DKException.hpp>
#include <DKDatastoreDefFed.hpp>
#include <DKDatastoreFed.hpp>
#include <DKDatastoreAdminFed.hpp>
#include <DKEntityDefFed.hpp>
#include <DKString.hpp>
#include <DKEnvironment.hpp>
#include <DKSequentialCollection.hpp>
#include <DKSearchTemplateFed.hpp>
#include <DKSearchCriteria.hpp>
#include <DKAttrDefFed.hpp>

void main(int argc, char *argv[])
{
	cout << "begin..." << endl;
	
    // Indicate this is a Console Application on Windows NT/95 for error
	// message code page conversion to OEM code page. If this was a Windows
	// GUI (Graphic User Interface) Application this would not be necessary
	// because DK_SS_WINDOWS is the default.
	DKEnvironment::setSubSystem(DK_SS_CONSOLE);

	if (argc < 5) {
		cout << "TADLstFed <feddb> <userid> <pw> <add/del/list>" << endl;
		return;
	}
	
   DKString libsrv  = argv[1];
   DKString userid  = argv[2];
   DKString pw      = argv[3];
   DKString cmd     = argv[4];

   DKDatastoreFed dsFed;

   try {

   // create federated datastore
   cout << "Datastore Fed created" << endl;
   cout << "connecting to datastore " << libsrv << endl;
   dsFed.connect(libsrv,userid,pw);
   cout << "datastore connected " << libsrv << " userid - " << userid << endl;
   
   DKString userName = dsFed.userName();
   DKString dsName   = dsFed.datastoreName();
   cout << "user " << userName << " dsName " << dsName << endl; 

   // get the Def
   dkDatastoreDef* defFed = dsFed.datastoreDef(); 
   DKDatastoreAdminFed* adm = (DKDatastoreAdminFed*) defFed->datastoreAdmin(); 

   // set up search criteria memory variable.
   short ops [] = { DK_CM_OPCODE_EQ, DK_CM_OPCODE_NEQ, DK_CM_OPCODE_LIKE, 
                    DK_CM_OPCODE_NOTLIKE, DK_CM_OPCODE_IN, DK_CM_OPCODE_NOTIN };

   //-------------------------------------------------------------- 
   // Create Search Criteria for FedTitle, FedUserId, FedDate
   //-------------------------------------------------------------- 
   DKSearchCriteria* scTitle = new DKSearchCriteria("FedDemo", "FedTitle");
      scTitle->setName("Title");
      scTitle->setDisplayName("Document Title");
   	  scTitle->setDefaultOperator(DK_CM_OPCODE_LIKE);
	  scTitle->setValidOperators(ops, 6);
      scTitle->setDisplayWidth((short)40);
	  scTitle->setQueryable(true);
	  scTitle->setDisplayable(true);

   DKSearchCriteria* scUserID = new DKSearchCriteria("FedDemo", "FedUserId");
      scUserID->setName("UserID");
      scUserID->setDisplayName("Document UserID");
      scUserID->setDefaultOperator(DK_CM_OPCODE_LIKE);
	  scUserID->setValidOperators(ops, 6);
      scUserID->setDisplayWidth((short)40);
	  scUserID->setQueryable(true);
	  scUserID->setDisplayable(true);

   DKSearchCriteria* scDate = new DKSearchCriteria("FedDemo", "FedDate");
      scDate->setName("Date");
      scDate->setDisplayName("Document Date");
      scDate->setDefaultOperator(DK_CM_OPCODE_LIKE);
	  scDate->setValidOperators(ops, 6);
      scDate->setDisplayWidth((short)40);
	  scDate->setQueryable(true);
	  scDate->setDisplayable(true);
	  scDate->setOperator(DK_CM_OPCODE_NEQ);
	  scDate->setValue("NULL");

   DKSearchCriteria* scTitle1 = new DKSearchCriteria("FedDemo", "FedTitle");
      scTitle1->setName("Title");
      scTitle1->setDisplayName("Document Title");
   	  scTitle1->setDefaultOperator(DK_CM_OPCODE_LIKE);
	  scTitle1->setValidOperators(ops, 6);
      scTitle1->setDisplayWidth((short)40);
	  scTitle1->setQueryable(true);
	  scTitle1->setDisplayable(true);

   DKSearchCriteria* scUserID1 = new DKSearchCriteria("FedDemo", "FedUserId");
      scUserID1->setName("UserID");
      scUserID1->setDisplayName("Document UserID");
      scUserID1->setDefaultOperator(DK_CM_OPCODE_LIKE);
	  scUserID1->setValidOperators(ops, 6);
      scUserID1->setDisplayWidth((short)40);
	  scUserID1->setQueryable(true);
	  scUserID1->setDisplayable(true);

   DKSearchCriteria* scDate1 = new DKSearchCriteria("FedDemo", "FedDate");
      scDate1->setName("Date");
      scDate1->setDisplayName("Document Date");
      scDate1->setDefaultOperator(DK_CM_OPCODE_LIKE);
	  scDate1->setValidOperators(ops, 6);
      scDate1->setDisplayWidth((short)40);
	  scDate1->setQueryable(true);
	  scDate1->setDisplayable(true);
	  scDate1->setOperator(DK_CM_OPCODE_NEQ);
	  scDate1->setValue("NULL");
   //-------------------------------------------------------------- 
   // Create Search Templates with FedUserId OR FedTitle OR FedDate
   //-------------------------------------------------------------- 
     DKSearchTemplateFed* stORS = new DKSearchTemplateFed(&dsFed);
                        stORS->setName("FedDemoST_ORS");
	                    stORS->setDescription("All ORS search template for FedDemo.");
	                    stORS->setParametricOp(DK_CM_OP_ALL_ORS);
	                    stORS->setEntityName("FedDemo");
		    
      if (cmd == "add") {
         stORS->add();     // Add search template to persistent datastore
	     stORS->addUser(dsFed.userName(), (short) DK_FED_ST_ACCESS_ADMIN);
		 stORS->add(scUserID);
		 stORS->add(scTitle);
		 stORS->add(scDate);
		 cout << "Successfully add search template with  FedUserId OR FedTitle OR FedDate" << endl;
      }
	  else if (cmd == "del") {
		 stORS->retrieve();
		 stORS->del();
		 cout << "Successfully delete search template with FedUserId OR FedTitle OR FedDate" << endl;
      }
		        
      
   //------------------------------------------------------------------ 
   // Create a Search Template with FedUserId AND FedTitle AND FedDate
   //------------------------------------------------------------------ 
      DKSearchTemplateFed* stANDS = new DKSearchTemplateFed(&dsFed);
                           stANDS->setName("FedDemoST_ANDS");
                           stANDS->setDescription("All ANDS search template for FedDemo.");
                           stANDS->setEntityName("FedDemo");
                           stANDS->setParametricOp(DK_CM_OP_ALL_ANDS);
		    
	  if (cmd == "add") {
	     stANDS->add();     // Add search template to persistent datastore
	     stANDS->addUser(dsFed.userName(), (short) DK_FED_ST_ACCESS_ADMIN);
	     stANDS->add(scUserID1);
	     stANDS->add(scDate1);
	     stANDS->add(scTitle1);
	     cout << "Successfully add search template with  FedUserId AND FedDate AND FedTitle" << endl;
      }
	  else if (cmd == "del") {
	     stANDS->retrieve();
	     stANDS->del();
	     cout << "Successfully delete search template with FedUserId AND FedDate AND FedTitle" << endl;
      }

   //-------------------------------------------------------------- 
   // Print out list of Search Templates 
   //-------------------------------------------------------------- 
   dkCollection* coll = dsFed.listSearchTemplates();
   dkIterator* iter = 0;
            
   if (coll != NULL) {
       iter = coll->createIterator();
       cout << " " << endl;
       cout << "-- list Search template -- " << endl;
       DKSearchTemplateFed* stObj;

       while (iter->more()) {
            stObj = (DKSearchTemplateFed*)(void *)(*iter->next());
            cout << endl << " *** Search Template Name : " << stObj->getName() << endl;
            cout << "    Description: " << stObj->getDescription() << endl;
            cout << "    Folder Name: " << stObj->getFolderName() << endl;
            cout << "    Entity Name: " << stObj->getEntityName() << endl;
            cout << " Parametric OP : ";
            if (stObj->getParametricOp() == DK_CM_OP_ALL_ANDS)
                cout << "DK_CM_OP_ALL_ANDS" << endl;
            else if (stObj->getParametricOp() == DK_CM_OP_ALL_ORS)
                cout << "DK_CM_OP_ALL_ORS" << endl;
                        
            dkCollection* scColl = stObj->listCriteria();
            dkIterator* scIter = scColl->createIterator();
            while (scIter->more()) {
                DKSearchCriteria* scObj = (DKSearchCriteria*) (void *)(*scIter->next());
                cout << "     ++ Criteria Name: " << scObj->getName() << endl;
                cout << "         Display Name: " << scObj->getDisplayName() << endl;
                cout << "          Entity Name: " << scObj->getEntityName() << endl;
                cout << "            Attr Name: " << scObj->getAttrName() << endl;
                cout << "           Default Op: " << scObj->getDefaultOperator() << endl;
                cout << "        Display Width: " << scObj->getDisplayWidth() << endl;
                cout << "            Queryable: " << scObj->isQueryable() << endl;
                cout << "          Displayable: " << scObj->isDisplayable() << endl;
                cout << " " << endl;
            }
            delete scIter;
            delete scColl;
            delete stObj;
        }
        delete iter;
        delete coll;
    }
    else 
       cout << "No Search template defines" << endl;

    delete stANDS;
    delete stORS;
   
    // disconnect
    dsFed.disconnect();
    cout << "Disconnect. Done." << endl;
  }   
       
  catch(DKException &exc)
  {
      cout << "Error id " << exc.errorId() << endl;
      for(unsigned long i = 0; i< exc.textCount();i++)
      {
         cout << "Error text: " << exc.text(i) << endl;
      }
      for (unsigned long g=0; g< exc.locationCount();g++)
      {
         const DKExceptionLocation* p = exc.locationAtIndex(g);
         cout << "Filename: " << p->fileName() << endl;
         cout << "Function: " << p->functionName() << endl;
         cout << "LineNumber: " << p->lineNumber() << endl;
      }
      
      cout << "Exception Class Name: " << exc.name() << endl;
  }
   
    cout << "done ..." << endl;   

}


