/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Information Integrator for Content V8.2  (program number 5724-B43)             *
 * (c ) Copyright IBM Corp. 1998, 2002, 2003. All Rights Reserved.                    *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************

  *** All documentation provided within the corresponding .cpp file. ***
  
    Please refer to the corresponding .cpp file for all documentation.

****************************************************************************************/
#ifndef _SSEARCHCALLBACKOBJECTICM_HPP_
#define _SSEARCHCALLBACKOBJECTICM_HPP_

    // Includes / Imports
    #include <dkCollection.hpp>

    // Sample Definition
    class SSearchCallbackObjectICM : public dkCallback{
    private:

        // Internal Variables
        dkCollection* results;                // Vector containing DKDDOs returned as results.
        bool          serverIsDone;           // Set to true when the server indicates that there are no more results to be returned.
        long          threshold;              // Size of sets to be returned by server.  This is to be specified by the user.
        bool          userRequestsCancel;     // Set to true when the object's cancelQuery() oeration is called by the User-Program
    
        // Error Detection Variables
        DKException*  firstException;         // First failure / exception caught, null if no errors

    public:

        SSearchCallbackObjectICM();
        ~SSearchCallbackObjectICM();

        //==================================================================================
        // dkCallback Interface
        //==================================================================================
        void      cancelQuery     ();
        DKBoolean dataCallback    (dkCollection* ddoList, DKBoolean resultsComplete);
        long      getThreshold    ();
        void      reportException (DKException* exc);
        void      setThreshold    (long nHitsThreshold);

        //==================================================================================
        // Helper Functions Used in This Object
        //==================================================================================
        bool          error             ();
        DKException*  getFirstException ();
        dkCollection* getResults        ();
        bool          isDone            ();

        //-------------------------------------------------------------------
	    // Wrapper Function Prototypes
        //-------------------------------------------------------------------
        // The following are wrapper functions for functionality covered
        // in this sample.  These functions may be used by other samples.

        // No additional wrapper functions from this sample.
    };

#endif
