/************************************************************************/
/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
/************************************************************************/

 // sample list catalog information from ODBC
 /*
 * Filename       : TListCatalogODBC.cpp
 * Description    : test DKDatastoreODBC listServers, listSchema,
 *                  listSchemaAttributes
 *
 */

#include <iostream.h>
#include <stdio.h>                
#include <DKConstant.h>
#include <DKDatastoreODBC.hpp>
#include <DKDatastoreDefODBC.hpp>
#include <DKException.hpp>
#include <DKString.hpp>
#include <DKSequentialCollection.hpp>
#include <DKColumnDefODBC.hpp>
#include <DKServerDefODBC.hpp>
#include <DKTableDefODBC.hpp>
#include <DKEnvironment.hpp>

void main(int argc, char *argv[])
{
   cout << "begin..." << endl;

   // Indicate this is a Console Application on Windows NT/95 for error
   // message code page conversion to OEM code page. If this was a Windows
   // GUI (Graphic User Interface) Application this would not be necessary
   // because DK_SS_WINDOWS is the default.
   DKEnvironment::setSubSystem(DK_SS_CONSOLE);

    //-------------------------------------------------------------- 
    // Checking for input parameters
    //--------------------------------------------------------------   
    DKString schema;
    if (argc < 4)
    {
     cout<<"Usage: "<<endl;
     cout<<"  TListCatalogODBC <db> <userid> <pw> [<schema-name> - optional] " << endl;
     return;
    }
    else if (argc == 5)
    {
     schema = argv[4];
    }

    // ### get input parameters
    DKString db = DKString(argv[1]);
    DKString userid = DKString(argv[2]);
    DKString pw = DKString(argv[3]);

   try {
      
      DKDatastoreODBC dsODBC;
      DKSequentialCollection *pCol = 0;
      dkIterator *pIter = 0;
      DKSequentialCollection *pCol2 = 0;
      dkIterator *pIter2 = 0;
      DKServerDefODBC *pSV = 0;
      DKTableDefODBC *pEnt = 0;
      DKString strServerName;
      DKString strTable;
      DKColumnDefODBC *pAttr = 0;
      DKDatastoreDefODBC *dsDefODBC = 0;
      DKAny a;
      DKAny *pA = 0;
      long i = 0;
      long j = 0;
      cout << "list servers" << endl;
      a = dsODBC.listDataSources();
      pCol = (DKSequentialCollection*)((dkCollection*)a);
      pIter = pCol->createIterator();
      while (pIter->more() == TRUE)
      {
       i++;
       pSV = (DKServerDefODBC*)((void*)(*pIter->next()));
       strServerName = pSV->getName();
       cout << "Server Name [" << i << "] - " << strServerName << endl; 
       delete pSV;
      }
      delete pIter;
      delete pCol;
      cout << i << " servers listed" << endl;
      cout << "connecting to datastore" << endl;
      dsODBC.connect(db,userid,pw);
      cout << "datastore connected " << db << " userid - " << userid << endl;
      dsDefODBC = (DKDatastoreDefODBC *) dsODBC.datastoreDef();
      if (schema != "")
      { 
       dsDefODBC->setSchemaName(schema);
       cout << " New Schema Name = [" << dsDefODBC->getSchemaName() << "]" << endl;
      }
      cout << "list tables" << endl;
      pCol = (DKSequentialCollection*)((dkCollection*)dsODBC.listEntities());
      pIter = pCol->createIterator();
      i = 0;
      while (pIter->more() == TRUE)
      {
       i++;
       pEnt = (DKTableDefODBC*)((void*)(*pIter->next()));
       strTable = pEnt->getName();
       cout << "table name [" << i << "] - " << strTable << endl;
       cout << "  list columns for " << strTable << " table" << endl;
       pCol2 = (DKSequentialCollection*)((dkCollection*)dsODBC.listEntityAttrs(strTable));
       pIter2 = pCol2->createIterator();
       j = 0;
       while (pIter2->more() == TRUE)
       {
        j++;
        pA = pIter2->next();
        pAttr = (DKColumnDefODBC*) pA->value();
        cout << "    Attribute name [" << j << "] - " << pAttr->getName() << endl;
        cout << "      datastoreName " << pAttr->datastoreName() << endl;
        cout << "      datastoreType " << pAttr->datastoreType() << endl;
        cout << "      attributeOf   " << pAttr->getEntityName() << endl;
        cout << "      type          " << pAttr->getType() << endl;
        cout << "      size          " << pAttr->getSize() << endl;
        cout << "      id            " << pAttr->getId() << endl;
        cout << "      nullable      " << pAttr->isNullable() << endl;
        cout << "      precision     " << pAttr->getPrecision() << endl;
        cout << "      scale         " << pAttr->getScale() << endl;
        cout << "      string type   " << pAttr->getStringType() << endl;
        cout << "      primary key   " << pAttr->isPrimaryKey() << endl;
        cout << "      foreign key   " << pAttr->isForeignKey() << endl;
        delete pAttr;
       }
       cout << "  " << j << " columns listed for " << strTable << " table" << endl;
       delete pIter2;
       delete pCol2;
       delete pEnt;
      }
      delete pIter;
      delete pCol;
      cout << i << " tables listed" << endl;
      dsODBC.commit();
      dsODBC.disconnect();
      cout << "datastore disconnected" << endl;
   }
   catch(DKException &exc)
   {
      cout << "Error id " << exc.errorId() << endl;
      for(unsigned long i = 0; i< exc.textCount();i++)
      {
         cout << "Error text: " << exc.text(i) << endl;
      }
      for (unsigned long g=0; g< exc.locationCount();g++)
      {
         const DKExceptionLocation* p = exc.locationAtIndex(g);
         cout << "Filename: " << p->fileName() << endl;
         cout << "Function: " << p->functionName() << endl;
         cout << "LineNumber: " << p->lineNumber() << endl;
      }

      cout << "Exception Class Name: " << exc.name() << endl;
   }
   
   cout << "done ..." << endl;
   
}
