/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

// sample connect/execute/disconnect to DB2

/*
 * Filename       : TClientExecuteDB2.java
 * Description    : Connect to DB2 Datastore.
 *                  Create query string.
 *                  Specify to retrieve folder and documents.
 *                  Specify to retrieve a max result of 5 items.
 *                  Get the result in a resultset cursor.
 *                  Loop thru results.
 *                  Display documents found and their parts and attributes,
 *                   if folders found display them and their documents/
 *                   folders.
 *                  Disconnect from DB2 Datastore.
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.client.*;
import java.io.*;
import java.lang.*;
import java.util.*;

// TClientExecuteDB2 class
public class TClientExecuteDB2 implements DKConstantDB2
{


   // Main method
   public static void main(String argv[])
   {

      //*** for input parameters
      String database = new String(""),   // database
             userid = new String(""),     //userid
             pw = new String(""); // pw

      // Indicate this is a Console Application on Windows NT/95 for error
      // message display in dos console code page. If this was a Windows
      // GUI (Graphic User Interface) Application this would not be necessary
      // because DK_CM_SS_WINDOWS is the default.
      DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);
      //--------------------------------------------------------------
      // Checking for input parameters
      //--------------------------------------------------------------

      if (argv.length < 3)
      {
         System.out.println("Usage: " );
         System.out.println("  java TClientExecuteDB2 " +
                            "<database> <userid> <pw>" );
         return;
      }
      else
      {
         database = argv[0];
         userid = argv[1];
         pw = argv[2];
      }

      DKDatastoreDB2 dsDB2 = null;
      try
      {
         // dsDB2 = new DKDatastoreDB2(configuration);
         // Constructing using default constuctor with init method
         dsDB2 = new DKDatastoreDB2();
         dkResultSetCursor pCur = null;
         DKNVPair parms[] = new DKNVPair[2];
         String strMax = "5";
         parms[0] = new DKNVPair(DK_CM_PARM_MAX_RESULTS,strMax);
         parms[1] = new DKNVPair(DK_CM_PARM_END,null);
         System.out.println("connecting to datastore");
         dsDB2.connect(database,userid,pw,"");
         System.out.println("datastore connected " + database + " userid - " + userid);
         String cmd = "";
         cmd = "SELECT * FROM EMPLOYEE";
         System.out.println("datastore connected");
         DKDDO p = null;
         DKDDO pDDO = null;
         dkXDO pXDO = null;
         int i = 0;
         int numDataItems = 0;
         short k = 0;
         short j = 0;
         String strDataName;
         dkCollection pCol = null;
         dkIterator pIter = null;
         Object a = null;
         dkDataObjectBase pDO = null;
         int cnt = 0;
         System.out.println("query string " + cmd);
         System.out.println("executing query");
         pCur = dsDB2.execute(cmd,DK_CM_SQL_QL_TYPE,parms);
         System.out.println("datastore executed query");
         System.out.println("cardinality " + pCur.cardinality());
         //    System.out.println("process query results");
         if (pCur == null)
         {
            System.out.println("cursor null");
         }
         while (pCur.isValid())
         {
            p = pCur.fetchNext();
            if (p != null)
            {
               cnt++;
               i = pCur.getPosition();
               System.out.println("=====> Item " + i + " <=====");
               numDataItems = p.dataCount();
               DKPid pid = p.getPidObject();
               System.out.println("pid string " + pid.pidString());
               System.out.println("Number of Data Items " + numDataItems);
               for (j = 1; j <= numDataItems; j++)
               {
                  a = p.getData(j);
                  strDataName = p.getDataName(j);
                  System.out.println(j + ": Attribute Name " + strDataName );
                  System.out.println("type " + p.getDataPropertyByName(j,DK_PROPERTY_TYPE));
                  System.out.println("nullable " + p.getDataPropertyByName(j,DK_PROPERTY_NULLABLE));
                  if (a instanceof String)
                  {
                     System.out.println("   Attribute Value " + a);
                  }
                  else if (a instanceof Integer)
                  {
                     System.out.println("   Attribute Value " + a);
                  }
                  else if (a instanceof Short)
                  {
                     System.out.println("   Attribute Value " + a);
                  }
                  else if (a instanceof dkCollection)
                  {
                     System.out.println("   Attribute Value is a collection");
                     pCol = (dkCollection)a;
                     pIter = pCol.createIterator();
                     i = 0;
                     while (pIter.more() == true)
                     {
                        i++;
                        a = pIter.next();
                        pDO = (dkDataObjectBase)a;
                        if (pDO.protocol() == DK_PDDO)
                        {
                           System.out.println("    DKDDO object " + i + " in collection");
                           pDDO = (DKDDO)pDO;
                        }
                        else if (pDO.protocol() == DK_XDO)
                        {
                           System.out.println("    dkXDO object " + i + " in collection");
                           pXDO = (dkXDO)pDO;
                           // Retrieve and open instance handler for an XDO
                           // pXDO.retrieve();
                           // pXDO.open();
                        }
                     }  // end while...
                  }  // end if dkCollection...
                  else if (a != null)
                  {
                     System.out.println("   Attribute Value " + a.toString());
                  }
                  else System.out.println("   Attribute Value is null");
               }  // end for
            }  // end if (p != null)
         }
         pCur.destroy(); // Finished with the cursor
         System.out.println("query results processed");
         System.out.println("Number of items " + cnt );
         dsDB2.commit();
         dsDB2.disconnect();
         System.out.println("datastore disconnected");
         dsDB2.destroy();
      }
      catch (DKException exc)
      {
         System.out.println("Exception name " + exc.name());
         System.out.println("Exception message " + exc.getMessage());
         exc.printStackTrace();
         try
         {
            if ( dsDB2 != null )
               dsDB2.destroy();
         }
         catch(Exception exc2)
         {}
      }
      catch (Exception exc)
      {
         System.out.println("Exception message " + exc.getMessage());
         exc.printStackTrace();
         try
         {
            if ( dsDB2 != null )
               dsDB2.destroy();
         }
         catch(Exception exc2)
        {}
      }

   }
}

