/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
                         
// sample create/delete a workbasket in WorkFlow/WorkBasket

/*
 * Filename : TCreateDelWorkBasketWFSDL.java
 * Description : Create/delete a workbasket in WorkFlow/WorkBasket
 *
 */
 
import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;
import java.io.*;

public class TCreateDelWorkBasketWFSDL
        implements DKConstantDL, DKMessageIdDL
{

  // Main method
  public static void main(String argv[])
  {
    System.out.println("begin...");

   // Indicate this is a Console Application on Windows NT/95 for error
   // message display in dos console code page. If this was a Windows
   // GUI (Graphic User Interface) Application this would not be necessary
   // because DK_CM_SS_WINDOWS is the default.
   DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

    DKDatastoreDL dsDL = null;
    try {
        dsDL = new DKDatastoreDL();
        Object input_option = new Integer(DK_DL_SS_CONFIG);
        Object output_option;
        DKWorkFlowServiceDL wfDL = new DKWorkFlowServiceDL(dsDL);
        String wbID;
	    int i = 0;

        System.out.println("Datastore DL created");
        dsDL.setOption(DK_DL_OPT_ACCESS, input_option);
        output_option = dsDL.getOption(DK_DL_OPT_ACCESS);
        System.out.println("DK_DL_OPT_ACCESS is " + output_option);
        System.out.println("connecting to datastore");
        dsDL.connect("LIBSRVRX", "FRNADMIN", "PASSWORD", "");
        System.out.println("datastore connected");
	    if (wfDL.isConnected())
	        System.out.println("workflow service has been connected");
	    else
	        System.out.println("workflow service is not connected");

        DKWorkBasketDL newwb = new DKWorkBasketDL(wfDL);
	    newwb.setName("Hot Items");
        newwb.setAccessList("All Privileges");
	    newwb.add();
	    System.out.println("A new workbasket has been created.");
	    newwb.retrieve();
	    System.out.println("WorkBasket ID is " + newwb.getID());
        System.out.println("WorkBasket Name is " + newwb.getName());
	    System.out.println("Access List Name is " + newwb.getAccessList());
	    System.out.println("WorkBasket " + newwb.getName() + " with ID " 
		              + newwb.getID() + " will be deleted.");
        newwb.del();

        dsDL.disconnect();
        System.out.println("datastore disconnected");
        dsDL.destroy();
    }
 
    catch(DKException exc)
    {
     try {
         dsDL.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
     System.out.println("Exception id " + exc.exceptionId());
     System.out.println("Exception Class Name: " + exc.name());
     System.out.println("Exception message " + exc.getMessage());
     System.out.println("Exception error code " + exc.errorCode());
     System.out.println("Exception error state " + exc.errorState());
     exc.printStackTrace();
    }
    catch (Exception exc)
    {
     try {
         dsDL.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }      
     System.out.println("Exception message " + exc.getMessage());
     exc.printStackTrace();
    }

    System.out.println("done ...");
  } // end of main    
    
}
