/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
import java.lang.*;
import java.util.*;
import com.ibm.mm.sdk.client.*;
import com.ibm.mm.sdk.common.*;

public class TConnectWFFedClient
{
   public static void main (String args []) 
   {
      try
      {
         System.out.println ("begin...");
         String wfsrv = "cmbdb";
         String userid = "cmbadmin";
         String pw = "password";

         DKDatastoreFed dsFed = new DKDatastoreFed();
         dsFed.connect (wfsrv, userid, pw, "");

         DKWorkFlowServiceFed svWF = new DKWorkFlowServiceFed (); 
         System.out.println ("Workflow Service MQWF created");

         svWF.setDatastore(dsFed);

         System.out.println ("connecting to workflow service");
         svWF.connect (wfsrv, userid, pw, "");
         System.out.println ("workflow service connected");
         System.out.println ("service type is " + svWF.serviceType ());

         svWF.disconnect ();
         System.out.println ("workflow service disconnected");
         dsFed.disconnect ();    
         svWF.destroy();  
         dsFed.destroy();
         System.out.println ( "done ...");
      }
      catch (DKException exc) 
      {
         System.out.println ("Exception name " + exc.name ());
         System.out.println ("Exception message " + exc.getMessage ());
         exc.printStackTrace ();
      }
      catch (java.lang.Exception ex) 
      { 
         ex.printStackTrace ();
      } 
   }
}
