/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/


import java.lang.*;
import com.ibm.mm.sdk.common.dkSchemaMapping;
import com.ibm.mm.sdk.common.dkAttrMapping;
import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;

class TSchemaMappingTextRetrieveFed
{
    public static void main(String argv[])
    {
        dkDatastore     _ds;
        dkSchemaMapping _sm;
        String          _servername;
        String          _servertype;
        String          _fentityname;
        String          _nentityname;
        short           _fentitytype;
        String          _fassocentityname;
        String          _nassocentityname;

        try {
            //initial();
            _sm = null;
            _servername = null;
            _servertype = null;
            _fentityname = null;
            _nentityname = null;
            _fassocentityname = null;
            _nassocentityname = null;
            _fentitytype = 0;

            _servername = "TEXTLAH";
            _fentityname = "TextEmployee";
            _nentityname = "EmpIndex";
            _fentitytype = 2;

            // create federated datastore
            _ds = new DKDatastoreFed();
            _ds.connect("feddb", "KIRK", "pw", "aa");

            //createSchemaMapping();
            _sm = new DKSchemaMappingFed(_ds);
            _sm.setServerName(_servername);
            _sm.setMappedEntityName(_fentityname);
            _sm.setMappedEntityType(_fentitytype);
            _sm.setEntityName(_nentityname);
            _sm.retrieve();

            System.out.println("-- SchemaMapping Name -- " + _sm.getName());
            System.out.println("-- Server Name -- " + _sm.getServerName());
            System.out.println("-- Server Type -- " + _sm.getServerType());
            System.out.println("-- Mapped Entity Name -- " + _sm.getMappedEntityName());
            System.out.println("-- Entity Name -- " + _sm.getEntityName());
            String[] ls = _sm.listAttrMappingNames();
            System.out.println("-- list AttrMapping Name -- ");
            for (int i = 0; i < ls.length; i++)
                System.out.println("    AttrMapping Name" + i + " = " + ls[i]);
            System.out.println("-- Assoc Server Name -- " + _sm.getAssocServerName());
            System.out.println("-- Assoc Mapped Entity Name -- " + _sm.getAssocMappedEntityName());
            System.out.println("-- Assoc Entity Name -- " + _sm.getAssocEntityName());

            _ds.disconnect();
            _ds.destroy();
        }
        catch (java.lang.Exception ex)
        {
            ex.printStackTrace();
        }
    }
}
